%% Cost function
%The missfit function ower the frequency using the missfit over time at
%each frequency
function E = misfit(d,dm)

    %Assume that the d and dm has the same length 
    nd = size(d);
    %Assume the number of frequencies is the length of the first size index and the
    %number of time sampels is the second
    Ef = zeros(nd(1),1);
    dt = zeros(nd(1),nd(2));
    dtm = zeros(nd(1),nd(2));
    %If there is just one time sample we only use the Bartlett cost
    %function and for the frequency in stead of time. If the there is more 
    %time samples we use the Bartlett cost function for the time samples
    %for each frequency
    if(nd(2) == 1)
        E = misfitf(d',dm');  
    else
        for i = 1:nd(1)
             dt(i,:) = d(i,:) - mean(d(i,:));
             dtm(i,:) = dm(i,:) - mean(dm(i,:));
             Ef(i) = misfitf(dt(i,:),dtm(i,:));
        end

            E = prod(Ef)^(1/nd(1));
    end
end

